<?php

include(dirname(__FILE__).'/../../config/config.inc.php');
include(dirname(__FILE__).'/intellectmoney.php');

	
function ob_exit($status = null)
{
	if($status) {
		ob_end_flush();
		isset($_REQUEST['debug']) ? exit($status) : exit();
	}
	else {
		ob_end_clean();
		header("HTTP/1.0 200 OK");
		echo "OK";
		exit();
	}
}

function debug_file()
{
	header('Content-type: text/plain; charset=utf-8');
	echo file_get_contents(__FILE__);
}

function check_im()
{
	// 91.212.151.242 -    
	if($_SERVER['HTTP_REFERER'] == "91.212.151.242")
		return true;
		
	return false;
}

function from_request($name)
{
	return isset($_REQUEST[$name]) ? trim(stripslashes($_REQUEST[$name])) : null;
}

if($_REQUEST['debug_file']) {
	debug_file();
	exit();
}

ob_start();

list($eshopId, $orderId, $serviceName, $eshopAccount, $recipientAmount, $recipientCurrency,
	$paymentStatus, $userName, $userEmail, $paymentData, $secretKey, $hash) =
array(
	from_request('eshopId'), from_request('orderId'), from_request('serviceName'), from_request('eshopAccount'), 
	from_request('recipientAmount'), from_request('recipientCurrency'), from_request('paymentStatus'), from_request('userName'), 
	from_request('userEmail'), from_request('paymentData'), from_request('secretKey'), from_request('hash')
);

$im = new Intellectmoney();
$cart = new Cart(intval($orderId));

$order_secretKey = Configuration::get('IM_KEY');
$order_eshopId = Configuration::get('IM_ACCOUNT');

//    
if($secretKey)
{
	//   (  )
	if($secretKey != $order_secretKey)
	{
		$err = "ERROR: SECRET_KEY MISMATCH!\n";
		$err .= check_im() ? ("secretKey: $secretKey; order_secretKey: ".$order_secretKey.";\n\n") : "\n";
		ob_exit($err);
	}
	
	//   
	if($eshopId != $order_eshopId)
	{
		$err = "ERROR: INCORRECT ESHOP_ID!\n";
		$err .= "eshopId: $eshopId; order_eshopId: ".$order_eshopId.";\n\n";
		ob_exit($err);
	}
}
//    
else
{
	$control_hash_str = implode('::', array(
		$eshopId, $orderId, $serviceName,
		$eshopAccount, $cart->getOrderTotal(), $im->getCurrency((int)$cart->id_currency)->iso_code, $paymentStatus,
		$userName, $userEmail, $paymentData, $order_secretKey,
	));
	$control_hash = md5($control_hash_str);
	$control_hash_utf8 = md5(iconv('windows-1251', 'utf-8', $control_hash_str));
		
	if (($hash != $control_hash && $hash != $control_hash_utf8) || !$hash) {
		$err = "ERROR: HASH MISMATCH\n";
		$err .= check_im() ? "Control hash string: $control_hash_str;\n" : "";
		$err .= "Control hash win-1251: $control_hash;\nControl hash utf-8: $control_hash_utf8;\nhash: $hash;\n\n";
		ob_exit($err);
	}
}

if ($paymentStatus == '3')
{
	$id_order = Order::getOrderByCartId(intval($orderId));
	$order = new Order($id_order);
	$order->setCurrentState(Configuration::get('PS_OS_WS_PAYMENT'));
	ob_exit();
}
if($paymentStatus == '5')
{
	$id_order = Order::getOrderByCartId(intval($orderId));
	$order = new Order($id_order);
	$order->setCurrentState(Configuration::get('PS_OS_PAYMENT'));
	ob_exit();
}

?>